package com.jd.lightapplication.easemob.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * 创建环信群组入参
 */
@Data
@Accessors(chain = true)
public class CreateGroupDto {
    @ApiModelProperty("群组名称，此属性为必须的")
    private String groupname;
    @ApiModelProperty("群组描述，此属性为必须的")
    private String desc;
    @ApiModelProperty("是否是公开群，此属性为必须的")
    private Boolean ispublic;
    @ApiModelProperty("群组成员最大数（包括群主），值为数值类型，默认值200，最大值2000，此属性为可选的")
    private Integer maxusers;
    @ApiModelProperty("加入公开群是否需要批准，默认值是false（加入公开群不需要群主批准），此属性为必选的，私有群必须为true")
    private Boolean approval;
    @ApiModelProperty("群组的管理员，此属性为必须的")
    private String owner;
    @ApiModelProperty("群组成员，此属性为可选的，但是如果加了此项，数组元素至少一个（注：群主jma1不需要写入到members里面）。")
    private List<String> members;
}
