package com.jd.lightapplication.model;

import java.io.Serializable;
import java.util.Date;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;


@Data
@ApiModel("巡检记录表")
@TableName("inspection_record")
@Accessors(chain = true)
public class InspectionRecord implements Serializable {
	private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("关联会议id")
    @TableField("meeting_id")
    private Long meetingId;

    @ApiModelProperty("巡检人员")
    @TableField("inspection_personnel")
    private String inspectionPersonnel;

    @ApiModelProperty("正常项目个数")
    @TableField("normal_num")
    private Integer normalNum;

    @ApiModelProperty("异常项目个数")
    @TableField("error_num")
    private Integer errorNum;

    @ApiModelProperty("巡检类型（10：日常巡检，20：会议巡检）")
    @TableField("inspection_type")
    private Integer inspectionType;

    @ApiModelProperty("创建时间")
    @TableField("create_time")
    private String createTime;

    @ApiModelProperty("修改时间")
    @TableField("update_time")
    private String updateTime;

    @ApiModelProperty("会议标题")
    @TableField(exist = false)
    private String meetingTitle;

}
