package com.jd.lightapplication.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;


@Data
@ApiModel("巡检结果表")
@TableName("inspection_result")
@Accessors(chain = true)
public class InspectionResult implements Serializable {
	private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("关联巡检记录id")
    @TableField("inspection_record_id")
    private Long inspectionRecordId;

    @ApiModelProperty("关联巡检项目id")
    @TableField("inspection_project_id")
    private Long inspectionProjectId;

    @ApiModelProperty("巡检结果类型（10：正常 20：不正常）")
    @TableField("result")
    private Integer result;

    @ApiModelProperty("巡检结果描述")
    @TableField("remark")
    private String remark;

    @ApiModelProperty("创建时间")
    @TableField("create_time")
    private String createTime;

}
