package com.jd.lightapplication.model;

import java.io.Serializable;
import java.util.Date;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;


@Data
@ApiModel("会议信息表")
@TableName("meeting_info")
@Accessors(chain = true)
public class MeetingInfo implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("会议标题")
    @TableField("title")
    private String title;

    @ApiModelProperty("接待对象")
    @TableField("reception_object")
    private String receptionObject;

    @ApiModelProperty("接待人数")
    @TableField("reception_number")
    private Integer receptionNumber;

    @ApiModelProperty("接待负责人")
    @TableField("reception_director")
    private String receptionDirector;

    @ApiModelProperty("接待内容")
    @TableField("reception_content")
    private String receptionContent;

    @ApiModelProperty("保障人员")
    @TableField("guarantee_personnel")
    private String guaranteePersonnel;

    @ApiModelProperty("接待要求")
    @TableField("reception_requirement")
    private String receptionRequirement;

    @ApiModelProperty("接待时间")
    @TableField("reception_time")
    private String receptionTime;

    @ApiModelProperty("巡检模板id")
    @TableField("inspection_template_id")
    private Long inspectionTemplateId;

    @ApiModelProperty("会议状态（10：未开始，20：已结束）")
    @TableField("status")
    private Integer status;

    @ApiModelProperty("创建时间")
    @TableField("create_time")
    private String createTime;

    @ApiModelProperty("修改时间")
    @TableField("update_time")
    private String updateTime;

}
