package com.jd.lightapplication.model;

import java.io.Serializable;
import java.util.Date;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;


@Data
@ApiModel("二维码展示配置")
@TableName("qrcode_show_config")
@Accessors(chain = true)
public class QrcodeShowConfig implements Serializable {
	private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("展示名称")
    @TableField("title")
    private String title;

    @ApiModelProperty("文件上传记录id")
    @TableField("upload_record_id")
    private Long uploadRecordId;

    @ApiModelProperty("状态（10：启用，20：禁用）")
    @TableField("status")
    private Integer status;

    @ApiModelProperty("创建时间")
    @TableField("create_time")
    private String createTime;

    @ApiModelProperty("修改时间")
    @TableField("update_time")
    private String updateTime;

    @ApiModelProperty("文件源名称")
    @TableField(exist = false)
    private String sourceName;

    @ApiModelProperty("文件访问地址")
    @TableField(exist = false)
    private String filePath;
}
