package com.jd.lightapplication.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;


@Data
@ApiModel("角色表")
@TableName("sys_role")
public class SysRole implements Serializable {
	private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("角色名称")
    @TableField("name")
    private String name;

    @ApiModelProperty("角色编码")
    @TableField("code")
    private String code;

    @ApiModelProperty("备注")
    @TableField("remark")
    private String remark;

    @ApiModelProperty("")
    @TableField("created")
    private LocalDateTime created;

    @ApiModelProperty("")
    @TableField("updated")
    private LocalDateTime updated;

    @ApiModelProperty("")
    @TableField("statu")
    private Integer statu;

    @TableField(exist = false)
    private List<Long> menuIds = new ArrayList<>();

}
