package com.jd.lightapplication.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.io.Serializable;


@Data
@ApiModel("文件上传记录")
@TableName("upload_record")
@Accessors(chain = true)
public class UploadRecord implements Serializable {
    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("关联巡检结果id，如果为空表示是图片回传")
    @TableField("inspection_result_id")
    private Long inspectionResultId;

    @ApiModelProperty("文件类型 10：图片回传 20：巡检结果")
    @TableField("file_type")
    private Integer fileType;

    @ApiModelProperty("源文件名称")
    @TableField("source_name")
    private String sourceName;

    @ApiModelProperty("文件地址")
    @TableField("file_path")
    private String filePath;

    @ApiModelProperty("操作人员id")
    @TableField("upload_user_id")
    private Long uploadUserId;

    @ApiModelProperty("创建时间")
    @TableField("create_time")
    private String createTime;

}
